# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse4016(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auth_credentials_link': 'str',
        'name': 'str',
        'endpoint_type': 'str',
        'endpoint_properties': 'dict(str, str)',
        'document_self_link': 'str',
        'tenant_links': 'list[str]',
        'custom_properties': 'dict(str, str)',
        'tag_links': 'list[str]',
        'matching_soft_constraints': 'int',
        'provider_type': 'str'
    }

    attribute_map = {
        'auth_credentials_link': 'authCredentialsLink',
        'name': 'name',
        'endpoint_type': 'endpointType',
        'endpoint_properties': 'endpointProperties',
        'document_self_link': 'documentSelfLink',
        'tenant_links': 'tenantLinks',
        'custom_properties': 'customProperties',
        'tag_links': 'tagLinks',
        'matching_soft_constraints': 'matchingSoftConstraints',
        'provider_type': 'providerType'
    }

    def __init__(self, auth_credentials_link=None, name=None, endpoint_type=None, endpoint_properties=None, document_self_link=None, tenant_links=None, custom_properties=None, tag_links=None, matching_soft_constraints=None, provider_type=None):  # noqa: E501
        """InlineResponse4016 - a model defined in Swagger"""  # noqa: E501
        self._auth_credentials_link = None
        self._name = None
        self._endpoint_type = None
        self._endpoint_properties = None
        self._document_self_link = None
        self._tenant_links = None
        self._custom_properties = None
        self._tag_links = None
        self._matching_soft_constraints = None
        self._provider_type = None
        self.discriminator = None
        if auth_credentials_link is not None:
            self.auth_credentials_link = auth_credentials_link
        if name is not None:
            self.name = name
        if endpoint_type is not None:
            self.endpoint_type = endpoint_type
        if endpoint_properties is not None:
            self.endpoint_properties = endpoint_properties
        if document_self_link is not None:
            self.document_self_link = document_self_link
        if tenant_links is not None:
            self.tenant_links = tenant_links
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if tag_links is not None:
            self.tag_links = tag_links
        if matching_soft_constraints is not None:
            self.matching_soft_constraints = matching_soft_constraints
        if provider_type is not None:
            self.provider_type = provider_type

    @property
    def auth_credentials_link(self):
        """Gets the auth_credentials_link of this InlineResponse4016.  # noqa: E501


        :return: The auth_credentials_link of this InlineResponse4016.  # noqa: E501
        :rtype: str
        """
        return self._auth_credentials_link

    @auth_credentials_link.setter
    def auth_credentials_link(self, auth_credentials_link):
        """Sets the auth_credentials_link of this InlineResponse4016.


        :param auth_credentials_link: The auth_credentials_link of this InlineResponse4016.  # noqa: E501
        :type: str
        """

        self._auth_credentials_link = auth_credentials_link

    @property
    def name(self):
        """Gets the name of this InlineResponse4016.  # noqa: E501


        :return: The name of this InlineResponse4016.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse4016.


        :param name: The name of this InlineResponse4016.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def endpoint_type(self):
        """Gets the endpoint_type of this InlineResponse4016.  # noqa: E501


        :return: The endpoint_type of this InlineResponse4016.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_type

    @endpoint_type.setter
    def endpoint_type(self, endpoint_type):
        """Sets the endpoint_type of this InlineResponse4016.


        :param endpoint_type: The endpoint_type of this InlineResponse4016.  # noqa: E501
        :type: str
        """

        self._endpoint_type = endpoint_type

    @property
    def endpoint_properties(self):
        """Gets the endpoint_properties of this InlineResponse4016.  # noqa: E501


        :return: The endpoint_properties of this InlineResponse4016.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._endpoint_properties

    @endpoint_properties.setter
    def endpoint_properties(self, endpoint_properties):
        """Sets the endpoint_properties of this InlineResponse4016.


        :param endpoint_properties: The endpoint_properties of this InlineResponse4016.  # noqa: E501
        :type: dict(str, str)
        """

        self._endpoint_properties = endpoint_properties

    @property
    def document_self_link(self):
        """Gets the document_self_link of this InlineResponse4016.  # noqa: E501


        :return: The document_self_link of this InlineResponse4016.  # noqa: E501
        :rtype: str
        """
        return self._document_self_link

    @document_self_link.setter
    def document_self_link(self, document_self_link):
        """Sets the document_self_link of this InlineResponse4016.


        :param document_self_link: The document_self_link of this InlineResponse4016.  # noqa: E501
        :type: str
        """

        self._document_self_link = document_self_link

    @property
    def tenant_links(self):
        """Gets the tenant_links of this InlineResponse4016.  # noqa: E501


        :return: The tenant_links of this InlineResponse4016.  # noqa: E501
        :rtype: list[str]
        """
        return self._tenant_links

    @tenant_links.setter
    def tenant_links(self, tenant_links):
        """Sets the tenant_links of this InlineResponse4016.


        :param tenant_links: The tenant_links of this InlineResponse4016.  # noqa: E501
        :type: list[str]
        """

        self._tenant_links = tenant_links

    @property
    def custom_properties(self):
        """Gets the custom_properties of this InlineResponse4016.  # noqa: E501


        :return: The custom_properties of this InlineResponse4016.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this InlineResponse4016.


        :param custom_properties: The custom_properties of this InlineResponse4016.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    @property
    def tag_links(self):
        """Gets the tag_links of this InlineResponse4016.  # noqa: E501


        :return: The tag_links of this InlineResponse4016.  # noqa: E501
        :rtype: list[str]
        """
        return self._tag_links

    @tag_links.setter
    def tag_links(self, tag_links):
        """Sets the tag_links of this InlineResponse4016.


        :param tag_links: The tag_links of this InlineResponse4016.  # noqa: E501
        :type: list[str]
        """

        self._tag_links = tag_links

    @property
    def matching_soft_constraints(self):
        """Gets the matching_soft_constraints of this InlineResponse4016.  # noqa: E501


        :return: The matching_soft_constraints of this InlineResponse4016.  # noqa: E501
        :rtype: int
        """
        return self._matching_soft_constraints

    @matching_soft_constraints.setter
    def matching_soft_constraints(self, matching_soft_constraints):
        """Sets the matching_soft_constraints of this InlineResponse4016.


        :param matching_soft_constraints: The matching_soft_constraints of this InlineResponse4016.  # noqa: E501
        :type: int
        """

        self._matching_soft_constraints = matching_soft_constraints

    @property
    def provider_type(self):
        """Gets the provider_type of this InlineResponse4016.  # noqa: E501


        :return: The provider_type of this InlineResponse4016.  # noqa: E501
        :rtype: str
        """
        return self._provider_type

    @provider_type.setter
    def provider_type(self, provider_type):
        """Sets the provider_type of this InlineResponse4016.


        :param provider_type: The provider_type of this InlineResponse4016.  # noqa: E501
        :type: str
        """

        self._provider_type = provider_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse4016, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse4016):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
